import React, { useEffect } from 'react';
import { InputNumber, Modal, Input, Table, Select, Form, Radio } from 'antd';
const { Option } = Select;

// 审批意见
function AuditModal(props) {
  const { visible, onCancel, onOk, roleList = [], data = {}, loading } = props;
  const [form] = Form.useForm();
  const formLayout = { labelCol: { span: 4 }, wrapperCol: { span: 14 } };

  const handleOk = async () => {
    let fieldsValue = await form.validateFields();
    // 如果id不存在则使用时间戳作为id
    fieldsValue.id = data?.id || new Date() * 1;
    onOk(fieldsValue);
  };

  useEffect(() => {
    if (visible) form.resetFields();
  }, [visible]);

  return (
    <Modal
      confirmLoading={loading}
      title="审批节点"
      visible={visible}
      onCancel={onCancel}
      onOk={handleOk}
    >
      <Form {...formLayout} form={form} initialValues={data}>
        <Form.Item label="节点名" name="node">
          <Input />
        </Form.Item>
        {/* <Form.Item label="审批级别" name="seq">
          <InputNumber style={{ width: '100%' }} step={1} min={1} />
        </Form.Item> */}
        <Form.Item label="审批角色" name="audit_role">
          <Select
            showSearch
            style={{ width: '100%' }}
            filterOption={(input, option) => option.props.children.indexOf(input) >= 0}
          >
            {roleList &&
              roleList.filter(item => item.RoleType == 4).map(item => (
                <Option key={item.ID} value={item.ID + ''}>
                  {item.Name}
                </Option>
              ))}
          </Select>
        </Form.Item>
        {/* <Form.Item initialValue={data?.seq_relate || 1} label="审批关系" name="seq_relate">
          <Radio.Group>
            <Radio value={1}>或</Radio>
            <Radio value={2}>并</Radio>
          </Radio.Group>
        </Form.Item> */}
      </Form>
    </Modal>
  );
}

export default AuditModal;
